//+------------------------------------------------------------------+
//|                                              EventProcessor9.mq5 |
//|                                           Copyright 2014, denkir |
//|                           https://login.mql5.com/ru/users/denkir |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, denkir"
#property link      "https://login.mql5.com/ru/users/denkir"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_BOOL
  {
   No=0,  // No
   Yes=1, // Yes
  };
//+------------------------------------------------------------------+
//| Inputs                                                           |
//+------------------------------------------------------------------+
sinput string Info_chart="+===--Chart--====+";   // +===--Chart--====+
input color InpBackColor=clrLavender;            // Background color
input ENUM_CHART_MODE InpMode=CHART_CANDLES;     // Chart mode
input ENUM_BOOL InpToShowGrid=Yes;               // To show grid?

//---     
int gChartWidth;
int gChartHeight;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {

//---
   return INIT_SUCCEEDED;
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

//---
   ChartRedraw();
//---
   Comment("");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,//  :
                  const long   &lparam,
                  const double &dparam,
                  const string &sparam
                  )
  {
   string comment=" : ";

//---   
   switch(id)
     {
      //--- 1
      case CHARTEVENT_KEYDOWN:
        {
         comment+="1)  ";
         //---
         break;
        }
      //--- 2
      case CHARTEVENT_MOUSE_MOVE:
        {
         comment+="2) ";
         //---
         break;
        }
      //--- 3
      case CHARTEVENT_OBJECT_CREATE:
        {
         comment+="3)   ";
         //---
         break;
        }
      //--- 4
      case CHARTEVENT_OBJECT_CHANGE:
        {
         comment+="4)      ";
         //---
         break;
        }
      //--- 5
      case CHARTEVENT_OBJECT_DELETE:
        {
         comment+="5)   ";
         //---
         break;
        }
      //--- 6
      case CHARTEVENT_CLICK:
        {
         comment+="6)    ";
         //---   
         break;
        }
      //--- 7
      case CHARTEVENT_OBJECT_CLICK:
        {
         comment+="7)     ";
         //---
         break;
        }
      //--- 8
      case CHARTEVENT_OBJECT_DRAG:
        {
         comment+="8)      ";
         //---
         break;
        }
      //--- 9
      case CHARTEVENT_OBJECT_ENDEDIT:
        {
         comment+="9)      ";
         //---
         break;
        }
      //--- 10
      case CHARTEVENT_CHART_CHANGE:
        {
         //---              
         int curr_ch_height=ChartHeightInPixelsGet();
         int curr_ch_width=ChartWidthInPixels();
         //---       
         if(gChartHeight==curr_ch_height && gChartWidth==curr_ch_width)
           {
            //---  :
            //---  
            if(!ChartShowGridSet(InpToShowGrid))
              {
               Print("Failed to show grid!");
               return;
              }
            //---   
            if(!ChartModeSet(InpMode))
              {
               Print("Failed to set mode!");
               return;
              }
            //---  
            if(!ChartBackColorSet(InpBackColor))
              {
               Print("Failed to set background olor!");
               return;
              }
           }
         //---   
         else
           {
            gChartHeight=curr_ch_height;
            gChartWidth=curr_ch_width;
           }
         //---
         comment+="10)  ";
         //---
         break;
        }
     }
//---
   Comment(comment);
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
bool ChartBackColorSet(const color clr,const long chart_ID=0)
  {
//---   
   ResetLastError();
//---    
   if(!ChartSetInteger(chart_ID,CHART_COLOR_BACKGROUND,clr))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
bool ChartModeSet(const long value,const long chart_ID=0)
  {
//---   
   ResetLastError();
//---   
   if(!ChartSetInteger(chart_ID,CHART_MODE,value))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//| /                      |
//+------------------------------------------------------------------+
bool ChartShowGridSet(const bool value,const long chart_ID=0)
  {
//---   
   ResetLastError();
//---   
   if(!ChartSetInteger(chart_ID,CHART_SHOW_GRID,0,value))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
