//+------------------------------------------------------------------+
//|                                              EventProcessor2.mq5 |
//|                                           Copyright 2014, denkir |
//|                           https://login.mql5.com/ru/users/denkir |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, denkir"
#property link      "https://login.mql5.com/ru/users/denkir"
#property version   "1.00"

//+------------------------------------------------------------------+
//| Easy access to the trade functions                               |
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_BOOL
  {
   No=0,  // No
   Yes=1, // Yes
  };
//+------------------------------------------------------------------+
//| Iputs                                                            |
//+------------------------------------------------------------------+
sinput string Info_flags="+===--Process events--====+";   // +===--Process events--====+
input ENUM_BOOL InpIsEventMouseMove=Yes;         // Process "Mouse move"?
//---
sinput string Info_trade="+===--Trade--====+";   // +===--Trade--====+
input double InpLot=0.02;                        // Lot
input int InpStopLoss=125;                       // Stop Loss
input int InpTakeProfit=250;                     // Take Profit
input int InpSlippage=50;                        // Slippage

//---
sinput string Info_chart="+===--Chart--====+";   // +===--Chart--====+
input double InpChartShiftSize=25.5;             // Chart shift size,%

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- mouse move
   bool is_mouse=false;
   if(InpIsEventMouseMove)
      is_mouse=true;
   ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,is_mouse);
//---
   return INIT_SUCCEEDED;
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   Comment("");
  }
//+------------------------------------------------------------------+
void OnChartEvent(const int id,//  :
                  const long   &lparam,
                  const double &dparam,
                  const string &sparam
                  )
  {
   string comment=" : ";

//---   
   switch(id)
     {
      //--- 1
      case CHARTEVENT_KEYDOWN:
        {
         comment+="1)  ";
         //---
         break;
        }
      //--- 2
      case CHARTEVENT_MOUSE_MOVE:
        {
         comment+="2) ";
         //---    
         if(InpIsEventMouseMove)
           {
            long static last_mouse_x;

            //---  
            if(ChartShiftSet(true))
               //---    
               if(ChartShiftSizeSet(InpChartShiftSize))
                 {
                  //---  
                  int chart_width=ChartWidthInPixels();

                  //---  X-  
                  int chart_shift_x=(int)(chart_width-chart_width*InpChartShiftSize/100.);

                  //---   
                  if(lparam>chart_shift_x && last_mouse_x<chart_shift_x)
                    {
                     int res=MessageBox(":  / : "," ",MB_YESNO);
                     //---  
                     if(res==IDYES)
                        TryToBuy();
                     //---  
                     else if(res==IDNO)
                        TryToSell();
                    }

                  //---  X- 
                  last_mouse_x=lparam;
                 }
           }

         //---
         break;
        }
      //--- 3
      case CHARTEVENT_OBJECT_CREATE:
        {
         comment+="3)   ";
         //--- 
         break;
        }
      //--- 4
      case CHARTEVENT_OBJECT_CHANGE:
        {
         comment+="4)      ";
         //---
         break;
        }
      //--- 5
      case CHARTEVENT_OBJECT_DELETE:
        {
         comment+="5)   ";
         //---
         break;
        }
      //--- 6
      case CHARTEVENT_CLICK:
        {
         comment+="6)    ";
         //---
         break;
        }
      //--- 7
      case CHARTEVENT_OBJECT_CLICK:
        {
         comment+="7)     ";
         //---
         break;
        }
      //--- 8
      case CHARTEVENT_OBJECT_DRAG:
        {
         comment+="8)      ";
         //---
         break;
        }
      //--- 9
      case CHARTEVENT_OBJECT_ENDEDIT:
        {
         comment+="9)   ";
         //---
         break;
        }
      //--- 10
      case CHARTEVENT_CHART_CHANGE:
        {
         comment+="10)  ";
         //---
         break;
        }
     }

//---
   Comment(comment);
  }
//+------------------------------------------------------------------+
//|  /       |
//|    .                                        |
//+------------------------------------------------------------------+
bool ChartShiftSet(const bool value,const long chart_ID=0)
  {
//---   
   ResetLastError();
//---   
   if(!ChartSetInteger(chart_ID,CHART_SHIFT,0,value))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|            |
//|     ( 10%  50%).      |
//| ,     CHART_SHIFT    |
//| true.                                                            |
//+------------------------------------------------------------------+
bool ChartShiftSizeSet(const double value,const long chart_ID=0)
  {
//---   
   ResetLastError();
//---   
   if(!ChartSetDouble(chart_ID,CHART_SHIFT_SIZE,value))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
bool TryToBuy(void)
  {
   bool is_done=false;
//---
   CTrade myTrade;
   MqlTick last_tick;
//---   
   if(SymbolInfoTick(_Symbol,last_tick))
     {
      myTrade.SetDeviationInPoints(InpSlippage);
      //--- 
      double open_pr,sl_pr,tp_pr;
      open_pr=sl_pr=tp_pr=WRONG_VALUE;
      //---
      open_pr=NormalizeDouble(last_tick.ask,_Digits);
      sl_pr=NormalizeDouble(open_pr-_Point*InpStopLoss,_Digits);
      tp_pr=NormalizeDouble(open_pr+_Point*InpTakeProfit,_Digits);

      //---   
      is_done=myTrade.Buy(InpLot,_Symbol,open_pr,sl_pr,tp_pr);
     }
//---
   return is_done;
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
bool TryToSell(void)
  {
   bool is_done=false;
//---
   CTrade myTrade;
   MqlTick last_tick;
//---   
   if(SymbolInfoTick(_Symbol,last_tick))
     {
      myTrade.SetDeviationInPoints(InpSlippage);
      //--- 
      double open_pr,sl_pr,tp_pr;
      open_pr=sl_pr=tp_pr=WRONG_VALUE;
      //---
      open_pr=NormalizeDouble(last_tick.bid,_Digits);
      sl_pr=NormalizeDouble(open_pr+_Point*InpStopLoss,_Digits);
      tp_pr=NormalizeDouble(open_pr-_Point*InpTakeProfit,_Digits);

      //---   
      is_done=myTrade.Sell(InpLot,_Symbol,open_pr,sl_pr,tp_pr);
     }
//---
   return is_done;
  }
//+------------------------------------------------------------------+
